
\ #include twi.frt

\    : -- create  over , + does> @i + ; \ struct

\ _twieeprom_

\ anew =twieeprom=
marker =twieeprom=

hex

$A0 value twi.ee-addr    \ twi address of the eeprom
$80 value page-size      \ bytes per block 24c512
 
: set-rw  1 or ;

\ directly address a single byte
: twi.ee-c! ( c addr -- )

  \ send device address
    twi.ee-addr
    twi.start
    twi.tx $18 twi.status?

  \ send eeprom cell address, high part first
    dup ><
    twi.tx $28 twi.status?
    twi.tx $28 twi.status?

  \ send data byte 
    twi.tx $28 twi.status?
    twi.stop
    ;

: twi.ee-c@ ( addr -- c )

    twi.ee-addr
    twi.start
    twi.tx        $18 twi.status?
    dup ><
    twi.tx        $28 twi.status?
    twi.tx        $28 twi.status?

  \ repeated start to read the data byte
    twi.start     $10 twi.status?
    twi.ee-addr set-rw
    twi.tx        $40 twi.status?
    twi.rxn       $58 twi.status?
    twi.stop
    ;

\ work on a page. a page is the operational unit
\ the eeprom works with internally. It's size is
\ defined in page-size. The pages are numbered
\ from 0 upward. page 1 has the starting address 
\ page-size.

: #page>addr ( pagenumber -- pageaddress )
    page-size log2 lshift ;
    ;

: twi.ee-saveblock ( ramaddr pagenumber -- )

    twi.ee-addr
    twi.start    
    twi.tx     $18 twi.status?
    #page>addr
    page-size 1- invert and \ mask the lower bits
    dup ><
    twi.tx     $28 twi.status?
    twi.tx     $28 twi.status?
    page-size  0
    ?do
	dup c@ 
	twi.tx $28 twi.status?
	1+
     loop
    drop
    twi.stop
    ;

: twi.ee-loadblock ( addr pagenumber -- )

    twi.ee-addr
    twi.start    
    twi.tx     $18 twi.status?
    #page>addr
    page-size 1- invert and \ mask the lower bits
    dup ><
    twi.tx     $28 twi.status?
    twi.tx     $28 twi.status?

  \ repeated start to receive the data bytes
    twi.start  $10 twi.status?
    twi.ee-addr set-rw 
    twi.tx     $40 twi.status?
    page-size  1- 0
     ?do
	twi.rx $50 twi.status?
	over c!
        1+
     loop
    twi.rxn    $58 twi.status?
    swap c!
    twi.stop
    ;

\
\ ====================================================
\




\
\ ====================================================
\


